#include "ti83plus.inc"
     .org 9D93h
     .db $BB,$6D

StartProg:
	bcall(_RunIndicOff)
	bcall(_RclAns)
	cp 0
	ret nz
	bcall(_ConvOP1)
	ld (intSeed), a
	

GameLoop:
	call CLS
	
	ld a, (intExpRequired)
	ld b, a
	ld a, (intPlayerEXP)
	cp b
	call nc, doLvl
	
	call MOVE
	call MOVE

	ld a, (isRunning)
	cp 0
	jp z, EndProg

	call dispRoom
	bcall(_GetKey)
	ld (tmpK), a
	cp kClear
	ret z

	; <Random Battle Initiation>
		ld a, 7
		call getRand
		ld a, b
		cp 2
		call z, BATTLE
		call updateSeed
	; </Random Battle Initiation>

	ld a, (isRunning)
	cp 1
	jp z, GameLoop

EndProg:
	ld a, 0
	ld (isRunning), a
	
	call CLS
	ld hl, strGameOver
	bcall(_PutS)
	bcall(_NewLine)
	ret

doLvl:
	ld a, (intPlayerLVL)
	cp 5
	ret z

	ld a, (intPlayerMATK)
	add a, 4
	ld (intPlayerMATK), a
	ld a, (intPlayerATK)
	add a, 3
	ld (intPlayerATK), a
	ld a, (intPlayerHP)
	add a, 20
	ld (intPlayerHP), a
	ld a, (intPlayerMP)
	add a, 20
	ld (intPlayerMP), a
	ld a, (intPlayerLVL)
	add a, 1
	ld (intPlayerLVL), a
	ld a, (intExpInc)
	ld b, a
	ld a, (intExpRequired)
	add a, b
	ld (intExpRequired), a
	ld a, (intExpInc)
	ld b, 2
	call MulAByB
	ld (intExpInc), a

	call CLS
	ld hl, lblLevelUp
	bcall(_PutS)
	bcall(_NewLine)
	bcall(_NewLine)
	ld hl, lblPause
	bcall(_PutS)
	bcall(_GetKey)
	
	ret

BATTLE:
	ld a, 0
	ld (tmpK), a
	call blackScreen
	ld a, (intFloor)
	cp 1
	call z, getEnemy1
	ld a, (intFloor)
	cp 2
	call z, getEnemy2
	ld a, (intFloor)
	cp 3
	call z, getEnemy3
	ld a, (intFloor)
	cp 4
	call z, getBoss

BATTLE_LOOP:
	call CLS
	; <Display Player Stats>
		ld a, (intHasPotion)
		cp 1
		jp nz, _SkipDisplayPotion
		ld a, 15
		ld (CURCOL), a
		ld a, 'O'
		bcall(_PutC)
_SkipDisplayPotion:
		ld a, 0	
		ld (CURROW), a
		ld (CURCOL), a

		ld hl, lblYou
		bcall(_PutS)
		bcall(_NewLine)
		ld hl, lblPlayerHP
		bcall(_PutS)
		ld a, (intPlayerHP)
		call AToString
		bcall(_PutS)
		ld a, ' '
		bcall(_PutC)
		ld hl, lblPlayerMP
		bcall(_PutS)
		ld a, (intPlayerMP)
		call AToString
		bcall(_PutS)
		bcall(_NewLine)
		bcall(_NewLine)
	; </Display Player Stats>
	; <Display Enemy Stats>
		ld a, (intFloor)
		cp 1
		call z, loadEnemy1
		ld a, (intFloor)
		cp 2
		call z, loadEnemy2
		ld a, (intFloor)
		cp 3
		call z, loadEnemy3
		ld a, (intFloor)
		cp 4
		call z, loadBoss
		bcall(_PutS)
		ld a, (intEnemyHP)
		call AToString
		bcall(_PutS)
	; </Display Enemy Stats>

	bcall(_NewLine)
	bcall(_NewLine)
	bcall(_NewLine)

	; <Display Options>
		call checkRunForDragon			

		ld a, (intMagicOption)
		cp 1
		jp z, _doDisplayOptionNext
		
		ld a, (intOption)
		cp 2
		call z, opt1
		ld a, (intOption)
		cp 3
		call z, opt2
		ld a, (intOption)
		cp 4
		call z, opt3
		jp _doDisplayOptionEnd

_doDisplayOptionNext:
		ld a, (intOption)
		cp 2
		call z, opt4
		ld a, (intOption)
		cp 3
		call z, opt5
		ld a, (intOption)
		cp 4
		call z, opt6
_doDisplayOptionEnd:
		call coverRunIfDragon
		
	; </Dispay Options>

	; <Handle Option Selection>
		ld a, (tmp)
		cp 66
		ret z
		bcall(_GetKey)
		ld (tmp), a
		cp kUp
		call z, btlSetMagicAttack
		ld (tmp), a
		cp kCapW
		call z, btlSetMagicAttack
		ld a, (tmp)
		cp kDown
		call z, btlSetMagicHeal
		ld a, (tmp)
		cp kCapS
		call z, btlSetMagicHeal
		ld a, (tmp)
		cp kDel
		call z, btlUsePotion
		ld (tmp), a
		cp kSpace
		call z, btlACTION
		ld (tmp), a
		cp kMode
		call z, btlACTION
		ld a, (tmp)
		cp kLeft
		call z, optLEFT
		ld a, (tmp)
		cp kCapA
		call z, optLEFT
		ld a, (tmp)
		cp kRight
		call z, optRIGHT
		ld a, (tmp)
		cp kCapD
		call z, optRIGHT
	; </Handle Option Selection>

	; <Check if the Enemy is Alive>
		ld a, (intEnemyHP)
		cp 1
		jp c, BATTLE_END
		ld a, (intEnemyHP_HEIGHT)
		add a, 1
		ld b, a
		ld a, (intEnemyHP)
		cp b
		jp nc, BATTLE_END
	; </Check if the Enemy is Alive>

	; <Check if the Player is Alive>
		ld a, (intPlayerHP)
		cp 1
		jp c, EndProg
		ld a, 200
		add a, 1
		ld b, a
		ld a, (intPlayerHP)
		cp b
		jp nc, EndProg
	; </Check if the Player is Alive>

	; <Check if Magic is Depleted>
		ld a, (intPlayerMP)
		cp 200
		jp c, _doResetMagicNext
		ld a, 0
		ld (intPlayerMP), a
_doResetMagicNext:
	; </Check if Magic is Depleted>

	jp BATTLE_LOOP

loadEnemy1:
	ld hl, nameEnemy1
	ret
loadEnemy2:
	ld hl, nameEnemy2
	ret
loadEnemy3:
	ld hl, nameEnemy3
	ret
loadBoss:
	ld hl, nameBoss
	ret
btlUsePotion:
	ld a, (intHasPotion)
	cp 1
	ret nz 
	
	ld a, 0
	ld (intHasPotion), a
	ld a, (intPlayerMP)
	add a, 20
	ld (intPlayerMP), a
	ld a, (intPlayerHP)
	add a, 20
	ld (intPlayerHP), a

	ret

coverRunIfDragon:
	ld a, (intFloor)
	cp 4
	ret nz

	ld a, 6	
	ld (CURROW), a
	ld a, 13
	ld (CURCOL), a
	ld a, ' '
	bcall(_PutC)
	bcall(_PutC)
	bcall(_PutC)

	ret
	
	
checkRunForDragon:
	ld a, (intFloor)
	cp 4
	ret nz

	ld a, (intOption)
	cp 4
	ret nz

	ld a, 3
	ld (intOption), a
	ret

BATTLE_END:
	call returnHP

	ld a, (intEnemyEXP)
	call getRand
	ld a, (intPlayerEXP)
	add a, b
	ld (intPlayerEXP), a
	call updateSeed
	ret

returnHP:
	ld a, (intPrevAttack)
	ld b, a
	ld a, (intPlayerHP)
	add a, b
	ld (intPlayerHP), a
	ret

btlACTION:

	ld a, (intOption)
	cp 2
	call z, btlATTACK

	ld a, (intOption)
	cp 3
	call z, btlMAGIC

	ld a, (intOption)
	cp 4
	call z, btlRUN

	ret

btlMAGIC:
	ld a, (intPlayerMP)
	cp 0
	ret z

	ld a, (intMagicOption)
	cp 1
	jp z, btlMagicAttack

	ld a, 2
	ld (intDoMagic), a
	call blackScreen	
	ld a, 0
	ld (intDoMagic), a

	ld a, (intPlayerMP)	
	sub 5
	ld (intPlayerMP), a

	ld a, (intPlayerMATK)
	call getRand
	ld a, (intPlayerHP)
	add a, b
	ld (intPlayerHP), a
	call updateSeed


	jp btlMagicEnd

btlMagicAttack:
	ld a, 1
	ld (intDoMagic), a
	call blackScreen	
	ld a, 0
	ld (intDoMagic), a

	ld a, (intPlayerMP)
	sub 10
	ld (intPlayerMP), a
	ld a, (intPlayerMATK)
	ld b, a
	ld a, (intPlayerATK)
	add a, b
	call getRand
	ld a, (intEnemyHP)
	sub b
	ld (intEnemyHP), a
	call updateSeed
	call btlATTACK_ENEMY

btlMagicEnd:
	ret

btlSetMagicAttack:
	ld a, 1
	ld (intMagicOption), a
	ret

btlSetMagicHeal:
	ld a, 0
	ld (intMagicOption), a
	ret

btlRUN:
	call btlATTACK_ENEMY
	
	ld a, 5
	call getRand
	ld a, b
	cp 2
	ret nz
	call returnHP
	ld a, 66
	ld (tmp), a
	ret
	
	
btlATTACK:
	call btlATTACK_ANI

	ld a, (intPlayerATK)
	call getRand

	ld a, (intEnemyHP)
	sub b
	ld (intEnemyHP), a

	call updateSeed
	call btlATTACK_ENEMY
	ret

btlATTACK_ENEMY:
	ld a, (intEnemyATK)	
	call getRand

	ld a, (intPlayerHP)
	sub b
	ld (intPlayerHP), a
	ld a, b
	ld (intPrevAttack), a

	call updateSeed
	ret

MOVE:
	ld a, (intFloor)
	cp 1
	call z, FLOOR1
	cp 2
	jp z, FLOOR2
	cp 3
	jp z, FLOOR3
	cp 4
	jp z, BOSS
;	cp 5
;	jp z, FLOOR5
;	ret

#include "floor1.inc"
#include "floor2.inc"
#include "floor3.inc"
#include "boss.inc"


movePosition:
	push af
	ld a, c
	ld (intPosition), a
	ld a, 0
	pop af
	ret

advanceFloor:
	push af
	ld a, 0
	ld (intPosition), a
	ld a, (intFloor)
	add a, 1
	ld (intFloor), a
	ld a, (intPlayerHP)
	add a, 20
	ld (intPlayerHP), a
	ld a, (intPlayerMP)
	add a, 20
	ld (intPlayerMP), a
	pop af
	ret

checkStart:
	ld a, (isBeginning)
	cp 1
	ret nz 

	ld hl, textWelcome	
	ld (textMAIN), hl
	ld a, 0
	ld (isBeginning), a

	ret

dispRoom:
	call CLS
	call checkStart
	; <Display Home>
		ld hl, lblFloor
		bcall(_PutS)
		ld a, (intFloor)
		call AToString
		bcall(_PutS)
		bcall(_NewLine)
		ld hl, lblPlayerLVL
		bcall(_PutS)
		ld a, (intPlayerLVL)
		call AToString
		bcall(_PutS)
		bcall(_NewLine)
		ld hl, lblPlayerEXP
		bcall(_PutS)
		ld a, (intPlayerEXP)
		call AToString
		bcall(_PutS)
		bcall(_NewLine)
		bcall(_NewLine)
		bcall(_NewLine)
		ld hl, (textMAIN)
		bcall(_PutS)
		ld a, 14
		ld (CURCOL), a
		ld a, 1
		ld (CURROW), a
		ld a, 'O'
		bcall(_PutC)	
	; </Display Home>

	ld a, (intFront)
	cp 1
	call z, putFront
	ld a, (intRight)
	cp 1
	call z, putRight
	ld a, (intBack)
	cp 1
	call z, putBack
	ld a, (intLeft)
	cp 1
	call z, putLeft

	ret

putFront:
	ld a, 14
	ld (CURCOL), a
	ld a, 0
	ld (CURROW), a
	ld a, '-'
	bcall(_PutC)
	ret	
putLeft:
	ld a, 13
	ld (CURCOL), a
	ld a, 1
	ld (CURROW), a
	ld a, '|'
	bcall(_PutC)
	ret
putRight:	
	ld a, 15
	ld (CURCOL), a
	ld a, 1
	ld (CURROW), a
	ld a, '|'
	bcall(_PutC)
	ret
putBack:
	ld a, 14
	ld (CURCOL), a
	ld a, 2
	ld (CURROW), a
	ld a, '-'
	bcall(_PutC)
	ret


blackScreen:
	ld a, 0
	ld (tmp), a
	call clearPixels
blackScreen_LOOP:
	ld a, (tmp)
	ld (_pixler_x), a
	ld a, 0
	ld (_pixler_y), a
	ld a, 1
	ld (_pixler_do_sprite), a
	ld a, (intDoMagic)
	cp 1
	jp z, blackScreen_LOOP_NEXT_1
	ld a, (intDoMagic)
	cp 2
	jp z, blackScreen_LOOP_NEXT_3
	ld de, sprBlackBar
	jp blackScreen_LOOP_NEXT_2	
blackScreen_LOOP_NEXT_1:
	ld de, sprBolt
	jp blackScreen_LOOP_NEXT_2
blackScreen_LOOP_NEXT_3:
	ld de, sprBrokenBar
blackScreen_LOOP_NEXT_2:		

	call printPixel
	call drawBuffer

	ld a, (tmp)
	cp 90
	jp z, blackScreen_NEXT
	ld a, (tmp)
	add a, 5
	ld (tmp), a
	jp blackScreen_LOOP
blackScreen_NEXT:
	ret
	


btlATTACK_ANI:
	ld a, 10
	ld (tmp), a

btlATTACK_ANI_LOOP:
	call clearPixels

	ld a, 44
	ld (_pixler_x), a
	ld a, (tmp)
	ld (_pixler_y), a
	ld a, 1
	ld (_pixler_do_sprite), a
	ld de, sprSword
	
	call printPixel
	call drawBuffer

	ld a, (tmp)
	sub 1
	ld (tmp), a
	cp -1
	jp nz, btlATTACK_ANI_LOOP

	ret

getEnemy1:
	ld a, 10
	ld (intEnemyHP), a
	ld (intEnemyHP_HEIGHT), a
	ld a, 5
	ld (intEnemyEXP), a
	ld a, 3
	ld (intEnemyATK), a
	ret

getEnemy2:
	ld a, 20
	ld (intEnemyHP), a
	ld (intEnemyHP_HEIGHT), a
	ld a, 25
	ld (intEnemyEXP), a
	ld a, 8
	ld (intEnemyATK), a
	ret

getEnemy3:
	ld a, 35
	ld (intEnemyHP), a
	ld (intEnemyHP_HEIGHT), a
	ld a, 45
	ld (intEnemyEXP), a
	ld a, 13
	ld (intEnemyATK), a
	ret

getBoss:
	ld a, 200
	ld (intEnemyHP), a
	ld (intEnemyHP_HEIGHT), a
	ld a, 100
	ld (intEnemyEXP), a
	ld a, 25
	ld (intEnemyATK), a
	ret

optLEFT:
	ld a, (intOption)
	cp 2
	ret z
	sub 1
	ld (intOption), a
	ret
optRIGHT:
	ld a, (intOption)
	cp 4
	ret z
	add a, 1
	ld (intOption), a
	ret

opt1:
	ld hl, strOpt1
	bcall(_PutS)
	ret
opt2:
	ld hl, strOpt2
	bcall(_PutS)
	ret
opt3:
	ld hl, strOpt3
	bcall(_PutS)
	ret

opt4:
	ld hl, strOpt4
	bcall(_PutS)
	ret
opt5:
	ld hl, strOpt5
	bcall(_PutS)
	ret
opt6:
	ld hl, strOpt6
	bcall(_PutS)
	ret
	
CLS:
	bcall(_ClrLCDFull)
	ld a, 0	
	ld (CURROW), a
	ld (CURCOL), a
	ret
lblLevelUp:
	.db "Level Up!", 0
lblPause:
	.db "Press any key tocontinue . . .", 0
nameEnemy1:
	.db "Blob: ", 0
nameEnemy2:
	.db "Skeleton: ", 0
nameEnemy3:
	.db "Knight: ", 0
nameBoss:
	.db "Dragon: ", 0
textWelcome:
	.db "Your quest has  begun.", 0
textStairs:
	.db "There appears tobe stairs ahead.", 0
lblYou:
	.db "You:", 0
lblPlayerHP:
	.db "HP: ",0
lblPlayerEXP:
	.db "EXP: ", 0
lblFloor:
	.db "Floor: ", 0
lblPlayerLVL:
	.db "LVL: ", 0
intPlayerHP:
	.db 40
lblPlayerMP:
	.db "MP: ",0
intPlayerMATK:
	.db 7
intPlayerMP:
	.db 20
intEnemyEXP:
	.db 0
intEnemyATK:
	.db 0
intPlayerATK:
	.db 5
intPlayerLVL:
	.db 1
intPlayerEXP:
	.db 0
intFloor:
	.db 1
intMagicOption: 
	.db 0
lblEnemy:
	.db "Enemy:", 0
lblEnemyHP:
	.db "HP: ",0	
intEnemyHP:
	.db 15
tmpK:
	.db 0
intFront:
	.db 0
intRight:
	.db 0
strGameOver:
	.db "Game Over.", 0
intBack:
	.db 0
intLeft:
	.db 0
intEnemyHP_HEIGHT:
	.db 100
intPosition:
	.db 0
tmp:
	.db 0
intHasPotion:
	.db 1
intExpRequired:
	.db 20
intExpInc:
	.db 30
intOption:
	.db 2
textMAIN:
	.db 0,0,0
nothing:
	.db 0,0,0
isBeginning:
	.db 1
strOpt1:
	.db "ATTACK mheal run",0
strOpt2:
	.db "attack MHEAL run",0
strOpt3:
	.db "attack mheal RUN",0
strOpt4:
	.db "ATTACK mattk run",0
strOpt5:
	.db "attack MATTK run",0
strOpt6:
	.db "attack mattk RUN",0
isRunning:
	.db 1
intPrevAttack:
	.db 0
intDoMagic:
	.db 0

sprSword:
	.db 00001000b
	.db 00010100b
	.db 00010100b
	.db 00010100b
	.db 00010100b
	.db 00010100b
	.db 01110111b
	.db 00111110b
	.db 00001000b
	.db 00001000b
	.db 00000000b

sprBlackBar:
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 11111111b
	.db 00000000b

sprBrokenBar:
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 01010101b
	.db 00000000b

sprBolt:
	.db 10000000b
	.db 10000000b
	.db 01000000b
	.db 01000000b
	.db 00100000b
	.db 00100000b
	.db 00010000b
	.db 00010000b
	.db 00001000b
	.db 00001000b
	.db 00000100b
	.db 00000100b
	.db 00000010b
	.db 00000010b
	.db 00000001b
	.db 00000001b
	.db 00000010b
	.db 00000010b
	.db 00000100b
	.db 00000100b
	.db 00001000b
	.db 00001000b
	.db 00010000b
	.db 00010000b
	.db 00100000b
	.db 00100000b
	.db 01000000b
	.db 01000000b
	.db 10000000b
	.db 10000000b
	.db 01000000b
	.db 01000000b
	.db 00100000b
	.db 00100000b
	.db 00010000b
	.db 00010000b
	.db 00001000b
	.db 00001000b
	.db 00000100b
	.db 00000100b
	.db 00000010b
	.db 00000010b
	.db 00000001b
	.db 00000001b
	.db 00000010b
	.db 00000010b
	.db 00000100b
	.db 00000100b
	.db 00001000b
	.db 00001000b
	.db 00010000b
	.db 00010000b
	.db 00100000b
	.db 00100000b
	.db 01000000b
	.db 01000000b
	.db 10000000b
	.db 10000000b
	.db 01000000b
	.db 01000000b
	.db 00100000b
	.db 00100000b
	.db 00010000b
	.db 00010000b
	.db 00000000b

	#include "pixler.inc"
.end
